<template>
	<div class="statistics-call-talk-time-container layout-pd">
		<!-- 搜索  -->
		<el-card shadow="never">
			<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline>
				<el-form-item label="时间段" prop="crTime">
					<el-date-picker
						v-model="state.queryParams.crTime"
						type="datetimerange"
						unlink-panels
						range-separator="至"
						start-placeholder="开始时间"
						end-placeholder="结束时间"
						:shortcuts="shortcuts"
						@change="queryList"
						value-format="YYYY-MM-DD[T]HH:mm:ss"
					/>
				</el-form-item>
				<el-form-item label-width="0">
					<el-button type="primary" @click="queryList" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
				</el-form-item>
			</el-form>
		</el-card>
		<el-card shadow="never">
			<ProTable
				ref="proTableRef"
				:columns="columns"
				:data="state.tableData"
				@updateTable="queryList"
				:loading="state.loading"
				:pagination="false"
				border
				show-summary
			>
			</ProTable>
		</el-card>
	</div>
</template>
<script setup lang="tsx" name="statisticsCallTalkTime">
import { onMounted, reactive, ref } from 'vue';
import { ElButton, FormInstance } from 'element-plus';
import { throttle } from '@/utils/tools';
import { callPeriod } from '@/api/statistics/call';
import { shortcuts } from '@/utils/constants';
import dayjs from 'dayjs';

const proTableRef = ref<RefType>(); // 表格ref
// 表格配置项
const columns = ref<any[]>([
	{ type: 'index', fixed: 'left', width: 55, label: '序号', align: 'center' },
	{ prop: 'hourTo', label: '时间段', align: 'center' },
	{ prop: 'count', label: '呼入总量', align: 'center' },
	{ prop: 'effectiveCount', label: '有效接通', align: 'center' },
	{ prop: 'connectByeCount', label: '接通秒挂', align: 'center' },
	{ prop: 'noConnectByeCount', label: '未接通秒挂', align: 'center' },
	{ prop: 'queueByeCount', label: '队列挂断', align: 'center' },
	{ prop: 'ivrByeCount', label: 'IVR挂断', align: 'center' },
]);
// 定义变量内容
const ruleFormRef = ref<RefType>(); // 表单ref
const state = reactive({
	queryParams: {
		// 查询条件
		Keyword: null, // 关键词
		crTime: [dayjs().startOf('day').format('YYYY-MM-DD HH:mm:ss'), dayjs().endOf('day').format('YYYY-MM-DD HH:mm:ss')], //
	},
	tableData: [], //表单
	loading: false, // 加载
	total: 0, // 总数
});
// 受理时间
/** 获取列表 */
const queryList = throttle(() => {
	state.loading = true;
	let beginDate = null;
	let endDate = null;
	if (state.queryParams?.crTime) {
		beginDate = state.queryParams?.crTime[0];
		endDate = state.queryParams?.crTime[1];
	}
	const request = {
		beginDate,
		endDate,
		DelayState: state.queryParams.DelayState,
		PageIndex: state.queryParams.PageIndex,
		PageSize: state.queryParams.PageSize,
		Keyword: state.queryParams.Keyword,
	};
	callPeriod(request)
		.then((res: any) => {
			state.tableData = res.result;
			state.loading = false;
		})
		.catch(() => {
			state.loading = false;
		});
}, 300);
/** 重置按钮操作 */
const resetQuery = throttle((formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
}, 300);
onMounted(() => {
	queryList();
});
</script>
